 // Последнее обновление 2017-08-15 by Phisik
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Здесь всяческий вывод на экран
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <OneWire.h>
#include <EEPROM.h>

#include "configuration.h"
#include "declarations.h"

char flNumStrPrint = 0;

void my_lcdprint(char *s)
{
  char i;
  char len;
  len = strlen(lcd_buffer);
  for (i = len; i < 16; i++) s[i] = ' ';
  s[16] = 0;

  if (IspReg == 111 && s[9] == 'R' && flNumStrPrint == 0) s[9] = 'N';

  lcd.print(s);

  // MQTT code by max506 & limon
#if defined(USE_MQTT_BROKER) && (USE_MQTT_BROKER==1)

  if (flNumStrPrint == 0) {

    sprintf_P(lcd_mqtt_buf1, fmt_lcd1, s);

    // Убрать завершающие пробелы
    for (i = strlen(lcd_mqtt_buf1) - 1; ; i--) {
      if (lcd_mqtt_buf1[i] == ' ') lcd_mqtt_buf1[i] = '\0';
      else break;
    }
  }
  else if (flNumStrPrint == 1) {

    sprintf_P(lcd_mqtt_buf2, fmt_lcd2, s);

    // Убрать завершающие пробелы
    for (i = strlen(lcd_mqtt_buf2) - 1; ; i--) {
      if (lcd_mqtt_buf2[i] == ' ') lcd_mqtt_buf2[i] = '\0';
      else break;
    }
  }

#endif // USE_MQTT_BROKER

#if USE_WiFi==1
  flNumStrPrint++;
#endif

#ifdef TESTMEM
  Serial.println(F("\n[memCheck_print]"));
  Serial.println(freeRam());
#endif
}

unsigned char hour, minute, second;
int V1, V2, V3;

void formTRZGDistill()
{
  if (TempDeflBegDistil > 0) sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), temps[TEMP_DEFL], TempDeflBegDistil, Power);
  else  sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), temps[TEMP_KUB], -TempDeflBegDistil, Power);

}

void formTSAErr()
{
  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u TSA!"), hour, minute, second);
  my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
  sprintf_P(lcd_buffer, PSTR("tT=%3i/%3i"), temps[TEMP_TSA], MAX_TEMP_TSA);
}

void DisplayRectif()
{
  if (DispPage == 0)
  {
    switch (StateMachine)
    {
      case 0: //Не запущено
      case 1: //Не запущено
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Rect"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tKub=%3i P=%4i"), temps[TEMP_KUB], Power);
        break;
      case 2: //Разгон
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u R RZG"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        if (tEndRectRazgon > 0) sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), temps[TEMP_KUB], tEndRectRazgon, UstPower);
        else sprintf_P(lcd_buffer, PSTR("tN=%3i/%3i %4iW"), temps[TEMP_RK20], -tEndRectRazgon, UstPower);
        break;
      case 3: //Стабилизация колонны
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u R NSB"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tN=%3i(%3i)%4iW"), temps[TEMP_RK20], (IspReg == 111 ? (int)(SecOstatok) : (int)(Seconds - SecTempPrev)), PowerRect);
        break;
      case 4: //Отбор голов
        if (IspReg != 118)
        {
          sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u R GLV"), hour, minute, second);
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          if (UrovenProvodimostSR == 0)
            sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), temps[TEMP_KUB], tEndRectOtbGlv, PowerRect);
          else if (UrovenProvodimostSR > 0)
          {
            if  (UrovenProvodimostSR == 2) sprintf_P(lcd_buffer, PSTR("Pr=%3i/%3i %4iW"), U_GLV, UROVEN_ALARM, PowerRect);
            else sprintf_P(lcd_buffer, PSTR("Pr=%3i/%3i %4iW"), U_GLV, UrovenProvodimostSR, PowerRect);
          }
          else
            sprintf_P(lcd_buffer, PSTR("Tm=%3i/%3i %4iW"), (int) SecOstatok, -UrovenProvodimostSR, PowerRect);
        }
        else
        {
          sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u RF GLV"), hour, minute, second);
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          if (TekFraction < CountFractionRect) V2 = TempFractionRect[TekFraction];
          if (V2 >= 0) sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), temps[TEMP_KUB], V2, UstPower);
          else sprintf_P(lcd_buffer, PSTR("t=%5imin %4iW"), (int) SecOstatok, UstPower);
        }
        break;
      case 5: //Стоп, ожидание возврата температуры
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u R Stop"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tN=%3i/%3i %2i%%"), temps[TEMP_RK20], tStabSR, ProcChimSR);
        break;
      case 6: //Ректификация
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u RSt %2i%%"), hour, minute, second, ProcChimSR);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tN=%3i/%3i/d%2i"), temps[TEMP_RK20], tStabSR + tDeltaRect, tDeltaRect);
        break;
      case 7: //Отбор хвостов
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u R Hvost"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i"), temps[TEMP_KUB], IspReg != 118 ? tEndRect : TekTemp);
        break;
      case 8: //Отбор ожидание 3 минут
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u R Wait"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i"), temps[TEMP_KUB], IspReg != 118 ? tEndRect : TekTemp);
        break;
      case 9: //Ожидание датчика уровня
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u R Wait"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("by Urov=%3i/%3i"), U_UROVEN, UROVEN_ALARM);
        break;
      case 100: //Окончание
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Rec End"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i End"), temps[TEMP_KUB], tEndRect);
        break;
      case 101: //Температура в ТСА превысила предельную
        formTSAErr();
        break;
      case 102: //Давление
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pres"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("MPX5010=%3i/%3i"), U_MPX5010, AlarmMPX5010);
        break;
    }
  }
  else
    {
    sprintf_P(lcd_buffer, PSTR("D2 T=%3i,%3i,%3i"), temps[0], temps[1], temps[2]);
    my_lcdprint(lcd_buffer);
    if (StateMachine != 5)
    {
      if (IspReg != 118)  sprintf_P(lcd_buffer, PSTR("%3immV=%4u,%4u"), U_MPX5010, U_UROVEN, U_GLV);
      else if (TekFraction < CountFractionRect)
      {
        if (TempFractionRect[TekFraction] > 0)
          sprintf_P(lcd_buffer, PSTR("%3imm t=%3i F%1i/%1i"), U_MPX5010, TempFractionRect[TekFraction], (int) TekFraction + 1, (int) CountFractionRect);
        else
          sprintf_P(lcd_buffer, PSTR("%3imm %4im F%1i/%1i"), U_MPX5010, (int) SecOstatok, (int) TekFraction + 1, (int) CountFractionRect);
      }
      else
        sprintf_P(lcd_buffer, PSTR("%3immV=%4u F%1i/%1i"), U_MPX5010, U_UROVEN, (int) TekFraction + 1, (int) CountFractionRect);
      }
    else sprintf_P(lcd_buffer, PSTR("%3imm reSt=%5i"), U_MPX5010, time1);
      }
   }

void DisplayDistDefl()
{
  if (DispPage == 0)
  {
    switch (StateMachine)
    {
      case 0: //Не запущено
      case 1: //Нагрев до температуры 50 градусов
        sprintf_P(lcd_buffer, PSTR("DDef %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        formTRZGDistill();
        break;
      case 2: //Ожидание закипания (прогреется дефлегматор)
        sprintf_P(lcd_buffer, PSTR("DDefRzg %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), temps[TEMP_DEFL], TempDeflBegDistil, UstPower);
        break;
      case 3: //Ожидание закипания (прогреется куб дефлегматор)
        sprintf_P(lcd_buffer, PSTR("DDefRzg %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), temps[TEMP_KUB], TempDeflBegDistil, UstPower);
        break;
      case 4: //Работа без дефлегматора
        sprintf_P(lcd_buffer, PSTR("DD BezD %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), temps[TEMP_DEFL], TempDefl, UstPower);
        break;
      case 5: //Работа с 50% дефлегмацией
        sprintf_P(lcd_buffer, PSTR("DD 50%% %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), temps[TEMP_DEFL], TempDefl - DeltaDefl, UstPower);
        break;
      case 6: //Работа с 100% дефлегмацией
        sprintf_P(lcd_buffer, PSTR("DD 100%% %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tD=%3i/%3i %4iW"), temps[TEMP_DEFL], TempDefl - DeltaDefl, UstPower);
        break;
      case 7: //Ожидание для охлаждения
        sprintf_P(lcd_buffer, PSTR("DD Wait %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i Wait=%4i"), temps[TEMP_KUB], SecondsEnd);
        break;
      case 100: //Окончание
        sprintf_P(lcd_buffer, PSTR("DD End %02u:%02u:%02u"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i end"), temps[TEMP_KUB]);
        break;
    }
  }
  else
  {
    sprintf_P(lcd_buffer, PSTR("D1 T=%3i,%3i,%3i"), temps[0], temps[1], temps[2]);
    my_lcdprint(lcd_buffer);
    sprintf_P(lcd_buffer, PSTR("Ur%4u,%4u-%4iW"), U_VODA, U_UROVEN, deltaPower);
  }

}

void DisplaySimpleDistill()
{
  if (DispPage == 0)
  {
    if (IspReg == 104)
    {
      V1 = 1;
      V2 = Temp1P;
    }
    if (IspReg == 106)
    {
      V1 = 2;
      V2 = Temp2P;
    }
    if (IspReg == 107   || IspReg == 105 )
    {
      V1 = 3;
      V2 = Temp3P;
    }

    if (IspReg != 105)  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u %1u-Otbor"), hour, minute, second, V1);
    else  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u sGl"), hour, minute, second);

    switch (StateMachine)
    {
      case 0: //Не запущено
      case 1: //Нагрев до температуры 50 градусов
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;
      case 2: //Ожидание закипания (прогреется дефлегматор)
        if (IspReg != 105)  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u %1u-O Rzg"), hour, minute, second, V1);
        else sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u sGl Rzg"), hour, minute, second, V1);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        formTRZGDistill();
        break;
      case 3: //Дистилляция
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), temps[TEMP_KUB], V2, UstPower);
        break;
      case 4: //Ожидание 60 секунд для охлаждения
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i Wait=%4i"), temps[TEMP_KUB], SecondsEnd);
        break;
      case 100: //Окончание
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i end"), temps[TEMP_KUB]);
        break;
      case 101: //Температура в ТСА превысила предельную
        formTSAErr();
        break;
    }
  }
  else
  {
    sprintf_P(lcd_buffer, PSTR("D1 T=%3i,%3i,%3i"), temps[0], temps[1], temps[2]);
    my_lcdprint(lcd_buffer);
    sprintf_P(lcd_buffer, PSTR("U_V%4u, U_U%4u"), U_VODA, U_UROVEN);
  }

}
void DisplayFracionDistill()
{
  if (DispPage == 0)
  {
    sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DsF %1i/%1i"), hour, minute, second, (int) (TekFraction < CountFractionDist) ? TekFraction + 1 : CountFractionDist, (int) CountFractionDist);

    switch (StateMachine)
    {
      case 0: //Не запущено
      case 1: //Нагрев до температуры 50 градусов
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;
      case 2: //Ожидание закипания (прогреется дефлегматор)
        sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u DsF Rzg"), hour, minute, second);
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        formTRZGDistill();
        break;
      case 3: //Дистилляция
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        if (TekFraction < CountFractionDist) V2 = TempFractionDist[TekFraction];
        if (V2 >= 0) sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i %4iW"), temps[TEMP_KUB], V2, UstPower);
        else sprintf_P(lcd_buffer, PSTR("t=%5imin %4iW"), (int) SecOstatok, UstPower);

        break;
      case 4: //Ожидание 60 секунд для охлаждения
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i Wait=%4i"), temps[TEMP_KUB], time3);
        break;
      case 100: //Окончание
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("tK=%3i end"), temps[TEMP_KUB]);
        break;
      case 101: //Температура в ТСА превысила предельную
        formTSAErr();
        break;
    }
  }
  else
  {
    sprintf_P(lcd_buffer, PSTR("D2 T=%3i,%3i,%3i"), temps[0], temps[1], temps[2]);
    my_lcdprint(lcd_buffer);
    sprintf_P(lcd_buffer, PSTR("U_V%4u,U_U%4u "), U_VODA, U_UROVEN);
  }

}

void DisplayTestKLP()
{
  if (DispPage == 0)
  {
    sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u tst Dev"), hour, minute, second);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("St=%3i CHIM=%3i"), StateMachine, ProcChimSR);
  }
  else
  {
    sprintf_P(lcd_buffer, PSTR("D1 T=%3i,%3i,%3i"), temps[0], temps[1], temps[2]);
    my_lcdprint(lcd_buffer);
    sprintf_P(lcd_buffer, PSTR(" Gas=%4u "), U_GAS);
  }

}

void DisplayData()
{
  int tic1;
  static int PrevState = 0;
  static char flDspDop = 0; // Флаг для отображения информации (через раз)
  char j; // Временная переменная для цикла
  flNumStrPrint = 0;
  flDspDop = !flDspDop;

  hour = Seconds / 3600;
  tic1 = Seconds % 3600;
  minute = tic1 / 60;
  second = tic1 % 60;

  if (FlState == 0)
    lcd.setCursor(0, 0);
  else
  {
    // Если предыдущее состояние было 0, то даем задерку в 1/10 секунды, чтобы не слишком часто обновлялся
    // дисплей.
    if (PrevState == 0)  delay(100);

    if (FlState != PrevState)
    {
      lcd.clear();  //очистка дисплея
      PrevState = FlState;
    }

    lcd.setCursor(0, 0);
  }

#ifdef TESTMEM
  Serial.println(F("\n[memCheck_displ]"));
  Serial.println(freeRam());
#endif

  switch (FlState)
  {
    case 0:

      if (DispPage < 2) // Первые две страницы отображаются по-разному, остальные всегда одни и те же
      {
        switch (IspReg)
        {
          case 101: // Displaying
            //sprintf_P(lcd_buffer,PSTR("S=%5u TT=%5u"),Seconds,MaxTimeTimer);

            //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
            //  это напряжение нужно для калибровки нашего измерителя

            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("Disp0   %02u:%02u:%02u"), hour, minute, second);
              my_lcdprint(lcd_buffer);
              sprintf_P(lcd_buffer, PSTR("%4iW, %3uV,%3uA"), FactPower, MaxVoltsOut, MaxIOut);
            }
            if (DispPage == 1)
            {
              sprintf_P(lcd_buffer, PSTR("D1 tK=%3i,tD=%3i"), temps[0], temps[1]);
              my_lcdprint(lcd_buffer);
              sprintf_P(lcd_buffer, PSTR("tTsa=%3i,P=%3imm"), temps[2], U_MPX5010);
            }
            break;
          case 102: // Термостат
            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("TermoSt %02u:%02u:%02u"), hour, minute, second);
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              sprintf_P(lcd_buffer, PSTR("tK=%3i/%3i(%2i) %1i"), temps[TEMP_TERMOSTAT], TempTerm, Delta, StateMachine);
            }
            else
            {
              sprintf_P(lcd_buffer, PSTR("D1 tK=%3i,tD=%3i"), temps[0], temps[1]);
              my_lcdprint(lcd_buffer);
              sprintf_P(lcd_buffer, PSTR("tTsa=%3i,P=%3imm"), temps[2], U_MPX5010);
//              sprintf_P(lcd_buffer, PSTR("D1 tK=%3i,Timer"), temps[0], Delta);
//              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
//              minute = Seconds / 60;
//              sprintf_P(lcd_buffer, PSTR("Minute=%4i/%4i"), minute, timerMinute);
             }
            break;
          case 108: // Таймер
            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Timer"), hour, minute, second, Delta);
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              minute = Seconds / 60;
              sprintf_P(lcd_buffer, PSTR("M%4i/%4i %4iW"), minute, timerMinute, UstPower);
            }
            else
            {
              sprintf_P(lcd_buffer, PSTR("D1 tK=%3i,tD=%3i"), temps[0], temps[1]);
              my_lcdprint(lcd_buffer);
              sprintf_P(lcd_buffer, PSTR("%3u,  %4iW"), temps[2], PowerMinute);
            }
            break;
          case 103: // Регулятор мощности
            if (DispPage == 0)
            {
              sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u RMU=%3u"), hour, minute, second, MaxVoltsOut);
              my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
              sprintf_P(lcd_buffer, PSTR("P=%4u/%4u c%3u"), UstPowerReg, Power, indexOut);
#ifdef TEST
              if (NUM_PHASE > 1) sprintf_P(lcd_buffer, PSTR("%s"), my_rx_buffer);
#endif
            }
            else
            {
              sprintf_P(lcd_buffer, PSTR("D2 T=%3i,%3i,%3i"), temps[0], temps[1], temps[2]);
              my_lcdprint(lcd_buffer);
              sprintf_P(lcd_buffer, PSTR("Up to auto=%4uW"), Power);
            }
            break;
          case 105: // Отбор голов33
          //          DisplaySimpleGLV();
          //          break;
          case 104: // Перевый (недробный) отбор
          case 106: // Второй дробный отбор
          case 107: // Третий дробный отбор
            DisplaySimpleDistill();
            break;

          case 117: // Фракционная перегонка
            DisplayFracionDistill();
            break;
          case 109: // Ректификация
          case 118: // Ректификация
            DisplayRectif();
            break;
#ifndef TEST
#ifndef DEBUG // Это отображение информации выкусываем, если в режиме теста, потому что не хватает памяти
#ifndef TESTWiFi
#ifndef TESTWiFi1
          case 110: // Дистилляция с дефлегматором
            DisplayDistDefl();
            break;
          case 111: // НДРФ
            //        DisplayRectif();
            break;
#endif
#endif
#endif
#endif
          case 130: // Внешнее управление
          case 129: // тест клапанов
            DisplayTestKLP();
            break;
          case 248:
            //          sprintf_P(lcd_buffer,PSTR("LOW LEVEL VOLTS!"));
            //          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            //          sprintf_P(lcd_buffer,PSTR("Umax=%i Sec=%3i"),MaxVoltsOut,(int) ErrCountIndex*12);
            break;
          case 249:
            sprintf_P(lcd_buffer, PSTR("NO DETECT ZERO!"));
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf_P(lcd_buffer, PSTR("Umax=%i"), MaxVoltsOut);
            break;
          case 250:
            sprintf_P(lcd_buffer, PSTR("ALARM VODA !"));
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
          case 251:
            sprintf_P(lcd_buffer, PSTR("ERR Ds18b20!"));
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            sprintf_P(lcd_buffer, PSTR("Num=%i"), (int) NumErrDs18);

            break;
          case 252:
            sprintf_P(lcd_buffer, PSTR("ALARM GAS SENS!"));
            my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
            break;
        }
      }
      // Третья страница это состояние регулятора мощности.
      if (DispPage == 2)
      {
        sprintf_P(lcd_buffer, PSTR("D2 FP%4iW, %3uV"), FactPower, MaxVoltsOut);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("P=%4u/%4u c%3u"), UstPowerReg, Power, indexOut);
        //      sprintf_P(lcd_buffer,PSTR("UP=%4iW,Zr=%4iu"),UstPower,TicZero);
      }
      // На четвёртой странице меняем состояние процесса
      if (DispPage == 3)
      {
        sprintf_P(lcd_buffer, PSTR("D3 State Debug"));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("StateMacine=%i"), (int)StateMachine);
      }
      // На пятой странице состояние датчиков уровней
      if (DispPage == 4)
      {
        sprintf_P(lcd_buffer, PSTR("D4 GL%3u, URV%3u"), U_GLV, U_UROVEN);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("VODA %3u, GAS%3u"), U_VODA, U_GAS);
      }
      // На Шестой странице показываем максимальные температуры за процесс температуру и давление
      if (DispPage == 5)
      {
        sprintf_P(lcd_buffer, PSTR("D5 MaxT=%3i, %3i"), Maxtemps[0], Maxtemps[1]);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("MaxTemp=%3i"), Maxtemps[2]);
      }
      // На Седьмой странице состояние ПИД-регулятора
      if (DispPage == 6)
      {
        sprintf_P(lcd_buffer, PSTR("D6 N=%4i,O=%4i"), NewErr, OldErrOut);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("Dt=%4i,It=%4i"), Dt, It);
      }
      // На Восьмой  странице показываем параметры расчета ПИД-регулятора
      if (DispPage == 7)
      {
        sprintf_P(lcd_buffer, PSTR("D7 N,O%3i,%3i"), NewErrTemp, OldErrTempOut);
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("KId%4i,%4i,%3i"), KtT, ItTemp, DtTemp);
      }
      // На девятой странице состояние WiFi
      if (DispPage == 8)
      {
#if USE_WiFi ==1
        sprintf_P(lcd_buffer, PSTR("D8 WiFi Status "));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR(" %3i, w%2u, i%3i"), (int)flWiFiState, (int)timeWaitWiFi, (int)timeWiFi);
#else
        sprintf_P(lcd_buffer, PSTR("D8 WiFi Disable!"));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("                "));
#endif
      }

      // На Десятой странице Ваши настройки для отображения в меню дисплея
      if (DispPage == 9)
      {
        sprintf_P(lcd_buffer, PSTR("D9 TEST"));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("D9 TEST"));
      }
      // На 11  странице Ваши настройки для отображения в меню дисплея
      if (DispPage == 10)
      {
        sprintf_P(lcd_buffer, PSTR("D10 TEST"));
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("D10 TEST"));
      }

      if (flDspDop && DispDopInfo > 0) // Если отображаем дополнительную информацию, тогда проверяем ее статус
      {
        if (BeepStateProcess > 1)
        {
          if (DispDopInfo == 5 || DispDopInfo == 6)
          {
            if (!(BeepStateProcess & B00000010) && DispDopInfo == 5) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 2 разряде
            if (!(BeepStateProcess & B00000100) && DispDopInfo == 6) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 3 разряде
          }
          else
            my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
        }
        else
          my_beep(BEEP_LONG); // Сначала пищим, предупреждая.

        if (DispDopInfo == 1) sprintf_P(lcd_buffer, PSTR("Smena TARA!(%3i)"), (IspReg == 117 || IspReg == 118) ? COUNT_ALARM_UROVEN_FR - CountAlarmUroven : COUNT_ALARM_UROVEN - CountAlarmUroven); //Выводим на экран инфомацию о необходимости замены тары.
        if (DispDopInfo == 2) sprintf_P(lcd_buffer, PSTR("VODA! (%3i)"), COUNT_ALARM_VODA - CountAlarmVoda); //Выводим на экран инфомацию о необходимости замены тары.
        if (DispDopInfo == 3) sprintf_P(lcd_buffer, PSTR("Low Power! %3iV"), MaxVoltsOut); //Выводим на экран инфомацию о низком напряжении.
        if (DispDopInfo == 6) sprintf_P(lcd_buffer, PSTR("HIGH Power! %3iV"), MaxVoltsOut); //Выводим на экран инфомацию о высоком напряжении.
        if (DispDopInfo == 4) sprintf_P(lcd_buffer, PSTR("Err temp! ds=%2i"), (int) NumErrDs18 ); //Выводим на экран инфомацию о ошибке чтения датчика.
        if (DispDopInfo == 5) sprintf_P(lcd_buffer, PSTR("!PRESS=%3i/%3i"), U_MPX5010, AlarmMPX5010); //Выводим на экран инфомацию о ошибке чтения датчика.

#if USE_WiFi  == 1
        // Активизируем разовую отправку состояния на сервер
        if (flWiFiState != 164 && (timeWiFi == 0 || flNeedCall == 1) )
        {
          if (flNeedCall == 1)
          {
            flWiFiState = 40; // Активируем звонок если в этом есть необходимость
          }
          else
          { // Если в данный момент не производится дозвон, тогда активируем WiFi сессию.
            if (flNeedCall != 2) flWiFiState = 2;
          }
          // Активируем длительную сессию WiFi
          flNeedRefrServer = 0;
          timeWiFi = 250;
          }
#endif
      }

      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

      break;
    case 100:
      sprintf_P(lcd_buffer, PSTR("Settings Menu"), FlState);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 101:
      sprintf_P(lcd_buffer, PSTR("Monitoring Mode "));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 102:
      sprintf_P(lcd_buffer, PSTR("IsR = Termostat"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 103:
      sprintf_P(lcd_buffer, PSTR("Power Regulator"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 104:
      sprintf_P(lcd_buffer, PSTR("1st distillation"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("(non-fractional)"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 105:
      sprintf_P(lcd_buffer, PSTR("IsR = otbor GLV"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 106:
      sprintf_P(lcd_buffer, PSTR("IsR = 2 DR otbor"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 107:
      sprintf_P(lcd_buffer, PSTR("IsR = 3 DR otbor"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 109:
      sprintf_P(lcd_buffer, PSTR("Rectification"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 110:// Дистилляция с дефлегматором
      sprintf_P(lcd_buffer, PSTR("IsR = Dist Defl"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 108:// Таймер
      sprintf_P(lcd_buffer, PSTR("Power regulator"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("+ Shutdown Timer"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 117:// Фракционная дистилляция
      sprintf_P(lcd_buffer, PSTR("IsR = Distill"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Fractional"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 118:// Фракционная ректификация
      sprintf_P(lcd_buffer, PSTR("IsR = Rectif"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Fractional"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 130:
    case 129:
      sprintf_P(lcd_buffer, PSTR("Valve Test Mode"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("                "));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 200:
      sprintf_P(lcd_buffer, PSTR("Max_t_Tst=%5i"), TempTerm);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 201:
      sprintf_P(lcd_buffer, PSTR("TEH Nominal"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Power=%5u"), Power);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 202:
      sprintf_P(lcd_buffer, PSTR("Current TEH"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Power=%5u"), UstPowerReg);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 203:
      sprintf_P(lcd_buffer, PSTR("ParamUSART=%u"), FlToUSART);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 205:
      sprintf_P(lcd_buffer, PSTR("dtTermostat=%3i"), Delta);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 206:
      sprintf_P(lcd_buffer, PSTR("1st Distillation"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("T_end=%3i"), Temp1P);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 207:
      sprintf_P(lcd_buffer, PSTR("Temp 2 Drobn"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%3i"), Temp2P);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 208:
      sprintf_P(lcd_buffer, PSTR("Temp 3 Drobn"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%3i"), Temp3P);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 209:
      sprintf_P(lcd_buffer, PSTR("Rect. Preheating"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("(+/-)T_end=%3i"), tEndRectRazgon);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 210:
      sprintf_P(lcd_buffer, PSTR("Rect. Regulator"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Power=%3i"), PowerRect);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 211:
      sprintf_P(lcd_buffer, PSTR("Corrections for"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("ds18b20 values"));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 212:
      sprintf_P(lcd_buffer, PSTR("Rect. Head"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("T_end=%3i"), tEndRectOtbGlv );
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 213:
      sprintf_P(lcd_buffer, PSTR("Rect. Head PWM"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Period=%5u"), timeChimRectOtbGlv);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 214:
      sprintf_P(lcd_buffer, PSTR("Rect. Head"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("%% PWM=%3i"), (int) ProcChimOtbGlv);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 215:
      sprintf_P(lcd_buffer, PSTR("Rect. C2H5OH PWM"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Period=%5u"), timeChimRectOtbSR);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 216:
      sprintf_P(lcd_buffer, PSTR("Rect. C2H5OH"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Delta=%3u"), tDeltaRect);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 217:
      sprintf_P(lcd_buffer, PSTR("Rect. C2H5OH"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("T_end=%3i"), tEndRectOtbSR);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 218:
      sprintf_P(lcd_buffer, PSTR("Rect. Shutdown"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("T_end=%3i"), tEndRect);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 250:
      sprintf_P(lcd_buffer, PSTR("Rect. C2H5OH"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("min %% PWM=%2i"), minProcChimOtbSR);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 251:
      sprintf_P(lcd_buffer, PSTR("Rect. Adjust"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("T_stable=%3i"), tStabSR);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 252:
      sprintf_P(lcd_buffer, PSTR("Rect. C2H5OH"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("start %% PWM=%2i"), begProcChimOtbSR);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 253:
      sprintf_P(lcd_buffer, PSTR("Popr MPX=%4i"), P_MPX5010);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("%4i/%4i"), U_MPX5010, U_MPX5010 + P_MPX5010);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 219:
      sprintf_P(lcd_buffer, PSTR("Power GLV simple"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%4i"), PowerGlvDistil);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 220:
      sprintf_P(lcd_buffer, PSTR("Power simple"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Distill=%4i"), PowerDistil);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 221:
      sprintf_P(lcd_buffer, PSTR("Temp Begin Dist"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("(+Def -Kub)=%3i"), TempDeflBegDistil);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 222:
      sprintf_P(lcd_buffer, PSTR("Temp Distill"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("With Defl=%3i"), TempDefl);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 223:
      sprintf_P(lcd_buffer, PSTR("Delta Distill"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("With Defl=%3i"), DeltaDefl);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 224:
      sprintf_P(lcd_buffer, PSTR("Temp Kub Okon"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("DistWithDefl=%3i"), tEndDistDefl);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 225:
      sprintf_P(lcd_buffer, PSTR("BeepEndProc=%1u"), BeepEndProcess);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 226:
      sprintf_P(lcd_buffer, PSTR("BeepStateProc=%1u"), BeepStateProcess);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 227:
      sprintf_P(lcd_buffer, PSTR("BeepKeyPress=%1u"), BeepKeyPress);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 230:
      sprintf_P(lcd_buffer, PSTR("Period Refresh"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Server(sec)=%3u"), (unsigned int) PeriodRefrServer);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer);
      break;
    case 231:
      sprintf_P(lcd_buffer, PSTR("U Peregrev=%3uV"), (unsigned int) NaprPeregrev);
      my_lcdprint(lcd_buffer);
      break;
    case 233:
      sprintf_P(lcd_buffer, PSTR("Provod SR=%4i"), UrovenProvodimostSR);
      my_lcdprint(lcd_buffer);
      break;
    case 234:
      sprintf_P(lcd_buffer, PSTR("Column Stabiliz."));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("(+/-)dt=%5isec"), TimeStabKolonna);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 235:
      sprintf_P(lcd_buffer, PSTR("Edit T & PWM"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Count PWM=%3i"), (int) CntCHIM);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 236:
      sprintf_P(lcd_buffer, PSTR("Rect. PWM Adjust"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Auto-%%PWM=%3i"), (int)DecrementCHIM);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer);
      break;
    case 237:
      sprintf_P(lcd_buffer, PSTR("Rect. PWM Adjust"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Auto+%%PWM=%3i"), (int)IncrementCHIM);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer);
      break;
    case 238:
      sprintf_P(lcd_buffer, PSTR("Rect. PWM Time +"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("%% PWM=%5isec"), TimeAutoIncCHIM);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 239:
      sprintf_P(lcd_buffer, PSTR("Column reStab."));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("(+/-)dt=%5isec"), TimeRestabKolonna);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 241:
      sprintf_P(lcd_buffer, PSTR("Power correct"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("ASC712 =%3i"), (int) CorrectASC712);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 246:
      sprintf_P(lcd_buffer, PSTR("Alarm Pressure"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("MPX5010=%i"), AlarmMPX5010);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 247:
      sprintf_P(lcd_buffer, PSTR("Use Avtonom"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("HLD=%i"), FlAvtonom);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 249:
      sprintf_P(lcd_buffer, PSTR("PID Paramters"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("%4i %4i %4i"), (int)PIDTemp[0], (int)PIDTemp[1], (int)PIDTemp[2]);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 257:
      sprintf_P(lcd_buffer, PSTR("Fraction Dist"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Count =%3i"), (int) CountFractionDist);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 258:
      sprintf_P(lcd_buffer, PSTR("Fraction Rectif"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Count =%3i"), (int) CountFractionRect);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 262:
      sprintf_P(lcd_buffer, PSTR("PhasePW %5i="), Power);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("%4i+%4i"), PowerPhase[0], PowerPhase[1]);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 263:
      break;
    case 268:
      sprintf_P(lcd_buffer, PSTR("%% otbor Tsarga"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Paster(+/-)=%3i"), (int)ProcChimOtbCP);
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 300:
      sprintf_P(lcd_buffer, PSTR("Temp%1i=%3u"), nPopr, temps[nPopr]);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Popr=%3i T=%3u"), ds1820_popr[nPopr], (temps[nPopr] + ds1820_popr[nPopr]));
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 301:
      sprintf_P(lcd_buffer, PSTR("TempK(%1i)=%4i"), (int) nPopr, tempK[nPopr]);
      if (flPopr == 0)
      {
        sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
      }

      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("CHIM(%1i)=%3i"), (int) nPopr, (int) CHIM[nPopr]);
      if (flPopr == 1)
      {
        sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
      }

      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
      if (flPopr == 1)
      {
        sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
      }

      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;

    case 309:
      sprintf_P(lcd_buffer, PSTR("%4i %4i %4i"), (int)PIDTemp[0], (int)PIDTemp[1], (int)PIDTemp[2]);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0, 1);
      if (nPopr == 0) sprintf_P(lcd_buffer, PSTR("   P"));
      if (nPopr == 1) sprintf_P(lcd_buffer, PSTR("        I"));
      if (nPopr == 2) sprintf_P(lcd_buffer, PSTR("             D"));
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 312:
      // последнее значение это тест фракционника
      if (nPopr == MAX_CNT_FRACTION_DIST)
      {
        sprintf_P(lcd_buffer, PSTR("Fraction Dist"));
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("Test =%3i"), (int) TekFraction + 1);
      }
      else
      {
        if (TempFractionDist[nPopr] >= 0)
          sprintf_P(lcd_buffer, PSTR("tFrDst(%1i)=%4i"), (int) nPopr + 1, (int) TempFractionDist[nPopr]);
        else
          sprintf_P(lcd_buffer, PSTR("timFD(%1i)=%5im"), (int) nPopr + 1, (int) - TempFractionDist[nPopr]);

        if (flPopr == 0)
        {
          sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
        }

        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

        if (flPopr == 1)  sprintf_P(lcd_buffer, PSTR("Angl=%3i*,%4iW"), (int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]);
        else  sprintf_P(lcd_buffer, PSTR("Angl=%3i ,%4iW"), (int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]);

        if (flPopr == 2)  sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
      }
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 313:
      // последнее значение это тест фракционника
      if (nPopr == MAX_CNT_FRACTION_RECT)
      {
        sprintf_P(lcd_buffer, PSTR("Fraction Rect"));
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("Test =%3i"), (int) TekFraction + 1);
      }
      else
      {
        if (TempFractionRect[nPopr] >= 0)
          sprintf_P(lcd_buffer, PSTR("tFrRect(%1i)=%4i"), (int) nPopr + 1, (int) TempFractionRect[nPopr]);
        else
          sprintf_P(lcd_buffer, PSTR("timFR(%1i)=%5im"), (int) nPopr + 1, (int) - TempFractionRect[nPopr]);

        if (flPopr == 0)
        {
          sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
        }

        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf_P(lcd_buffer, PSTR("Angle=%3i"), (int) AngleFractionRect[nPopr]);

        if (flPopr == 1)  sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
      }
      lcd.setCursor(0, 1);
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 314:
      break;
    case 315:
      break;
    default:
      break;
  }

  if (flNumStrPrint < 2)
  {
    lcd_buffer[0] = 0;
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
  }
  NeedDisplaying = false;

}
