// Updated on 2017-05-29 by lom
// Все пины теперь в одном месте, кроме нестандартных версий
// Контроль нуля идет на 1-е прерывание (это pin 3)
// Управление симистором для фазового регулятора мощности реализовано через PIN 36
// АЦП от трансформатора подключен на pin А2
// Датчики ds18b20 сидят на 37 пине.
// Пины с 7 по 13 можно освободить для использования встроенного ШИМ-а в Ардуино (тут надо быть внимательнее с таймерами!)

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Аналоговые выходы
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define PIN_LCD_KEYPAD       A0    		// Сюда подключаем кнопки от стандартного shield-a
#define PIN_READU            A2    		// Аналоговый Пин для чтения напряжения 
#define PIN_READI            A4 // or A2,  Пин для чтения тока 
#define PIN_ALARM_VODA       A5    		// Пин, на котором сидит датчик разлития воды на полу (да какой датчик, два луженых провода).     
#define PIN_ALARM_UROVEN     A6    		// Пин, на котором сидит датчик уровня в приемной емкости (да какой датчик, два луженых провода).
#define PIN_PROVODIMOST_SR   A7    		// Пин для анализа проводимости спирта (аналоговый пин А7)
#define PIN_GAS_SENSOR       A8    		// Пин для анализа датчика загазованности (спирта)
#define PIN_MPX5010          A9    		// Пин датчика давления MPX5010DP

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Цифровые выходы
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define PIN_ZEROS_DETECT     3    // Детектор нуля
#define PIN_LIGHT           10    // Тут можно лампочками поморгать
#define PIN_SOUND           11    // На 11 пине сидит спикер от компа (мощная штука, 15 ом, потребляет 300ма, поэтому ей пока не злоупотребляю, может заменить ее в дальнейшем на Пьезо?)
#define PIN_KLP_BEG         22    // 22-27  // Начальный пин для управления клапанами 
#define PIN_RZG_ON          30    // Пин для включения режима разгона (может работать и без него)
#define PIN_ALL_OFF         31    // Пин, при подаче напряжения на который вырубаеся вообще все (например выключается УЗО) (может работать и без него)
#define PIN_TRIAC           36    // Управление симистором реализовано через PIN 36
#define PIN_DS18B20         37    // Тут у нас подключены датчики
#define PIN_RST_WDT         43    // Пин, на который периодически меняется значение с 0 на 1 (раз в 5 секунд обычно) служит для отслеживаения зависания Ардуины внешним устройством.

# define PIN_START_1         4    // На этих двух пинах устанавливается заданный уровень при старте процесса и снимается при окончкни нагрева для включения индукционки через реле, например)
# define PIN_START_2         5    // Это пины стандратного шильда, если у Вас другой шильд, то поменять значения.

#define PRESS_SELECT     (KeyCode==1)  // Скобочки здесь нужно всегда ставить, на всякий случай,
#define PRESS_RIGHT      (KeyCode==2)  // т.к. могут быть очень трудноуловимые ошибки
#define PRESS_LEFT       (KeyCode==3)
#define PRESS_UP         (KeyCode==4)
#define PRESS_DOWN       (KeyCode==5)

